Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## sim.portrayal.grid
Class HexaSparseGridPortrayal2D

    java.lang.Object
      sim.portrayal.FieldPortrayal
          sim.portrayal.FieldPortrayal2D
              sim.portrayal.grid.SparseGridPortrayal2D
                  sim.portrayal.grid.HexaSparseGridPortrayal2D

All Implemented Interfaces:
  java.io.Serializable, Portrayal, Portrayal2D

    public class HexaSparseGridPortrayal2D

extends SparseGridPortrayal2D

Portrayal for hexagonal grids (each cell has six equally-distanced neighbors). It can draw either continuous and descrete sparse fields. The 'location' passed into the DrawInfo2D handed to the SimplePortryal2D is an Int2D.

See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class sim.portrayal.FieldPortrayal
`FieldPortrayal.CustomInspector`

Field Summary
`static double` | `HEXAGONAL_RATIO` The ratio of the width of a hexagon to its height: 1 / Sin(60 degrees), otherwise known as 2 / Sqrt(3)

Fields inherited from class sim.portrayal.grid.SparseGridPortrayal2D
`policy`

Fields inherited from class sim.portrayal.FieldPortrayal2D
`DEFAULT, DONT_USE_BUFFER, USE_BUFFER`

Fields inherited from class sim.portrayal.FieldPortrayal
`classPortrayals, dirtyField, field, immutableField, portrayalForAll, portrayalForNonNull, portrayalForNull, portrayalForRemainder, portrayals`

Constructor Summary
`HexaSparseGridPortrayal2D()`
`HexaSparseGridPortrayal2D(DrawPolicy policy)`

Method Summary
`java.lang.Object` | `getClipLocation(DrawInfo2D fieldPortrayalInfo)` Returns an object representing the location in the field of the origin of the clip of the DrawInfo2D.
`java.awt.geom.Point2D.Double` | `getLocationPosition(java.lang.Object location, DrawInfo2D info)` Returns the position on-screen of the provided location in the underlying field.
`java.lang.Object` | `getPositionLocation(java.awt.geom.Point2D.Double position, DrawInfo2D info)` Returns the Location, in the parlance of the underlying Field, of the given position.
`Double2D` | `getScale(DrawInfo2D info)` Returns the width and height, in pixels, of 1.0 x 1.0 units in the underlying field.
`protected void` | `hitOrDraw(java.awt.Graphics2D graphics, DrawInfo2D info, Bag putInHere)` Instead of overriding the draw and hitObjects methods, you can optionally override this method to provide both the draw(...) and hitObjects(...) functionality in a single method, as it's common that these two methods have nearly identical code.
`void` | `setObjectPosition(java.lang.Object object, java.awt.geom.Point2D.Double position, DrawInfo2D fieldPortrayalInfo)` Moves (or tries to move) the object to an internal location equivalent to the given position on-screen of the provided object, assuming that the object exists within the underlying field and that this location is acceptable.

Methods inherited from class sim.portrayal.grid.SparseGridPortrayal2D
`getDefaultPortrayal, getObjectLocation, getWrapper, setField, setSelected`

Methods inherited from class sim.portrayal.FieldPortrayal2D
`draw, getBuffering, getObjectPosition, getRelativeObjectPosition, hitObjects, setBuffering`

Methods inherited from class sim.portrayal.FieldPortrayal
`getDefaultNullPortrayal, getField, getInspector, getName, getPortrayalForAll, getPortrayalForNonNull, getPortrayalForNull, getPortrayalForObject, getPortrayalForRemainder, getStatus, isImmutableField, setImmutableField, setPortrayalForAll, setPortrayalForClass, setPortrayalForNonNull, setPortrayalForNull, setPortrayalForObject, setPortrayalForRemainder, setSelected`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface sim.portrayal.Portrayal
`getInspector, getName, getStatus`

Field Detail

### HEXAGONAL_RATIO

    public static final double HEXAGONAL_RATIO

  The ratio of the width of a hexagon to its height: 1 / Sin(60 degrees), otherwise known as 2 / Sqrt(3)

Constructor Detail

### HexaSparseGridPortrayal2D

    public HexaSparseGridPortrayal2D()

### HexaSparseGridPortrayal2D

    public HexaSparseGridPortrayal2D(DrawPolicy policy)

Method Detail

### setObjectPosition

    public void setObjectPosition(java.lang.Object object,
                                  java.awt.geom.Point2D.Double position,
                                  DrawInfo2D fieldPortrayalInfo)

  Description copied from class: `FieldPortrayal2D`
  Moves (or tries to move) the object to an internal location equivalent to the given position on-screen of the provided object, assuming that the object exists within the underlying field and that this location is acceptable. Optionally overridable. The default implementation does nothing.

  Overrides:
    `setObjectPosition` in class `SparseGridPortrayal2D`

### getClipLocation

    public java.lang.Object getClipLocation(DrawInfo2D fieldPortrayalInfo)

  Description copied from class: `FieldPortrayal2D`
  Returns an object representing the location in the field of the origin of the clip of the DrawInfo2D. This method calls getPositionLocation, which may or may not be implemented by the FieldPortrayal2D.

  Overrides:
    `getClipLocation` in class `SparseGridPortrayal2D`

### getScale

    public Double2D getScale(DrawInfo2D info)

  Description copied from class: `FieldPortrayal2D`
  Returns the width and height, in pixels, of 1.0 x 1.0 units in the underlying field. Optionally overridable. The default version thows an error if called.

  Overrides:
    `getScale` in class `SparseGridPortrayal2D`

### getPositionLocation

    public java.lang.Object getPositionLocation(java.awt.geom.Point2D.Double position,
                                                DrawInfo2D info)

  Description copied from class: `FieldPortrayal2D`
  Returns the Location, in the parlance of the underlying Field, of the given position. If there is no such Location, then null is returned. Optionally overridable. By default null is returned.

  Overrides:
    `getPositionLocation` in class `SparseGridPortrayal2D`

### getLocationPosition

    public java.awt.geom.Point2D.Double getLocationPosition(java.lang.Object location,
                                                            DrawInfo2D info)

  Description copied from class: `FieldPortrayal2D`
  Returns the position on-screen of the provided location in the underlying field. Negative positions are acceptable. If null is returned, then the portrayal is unable to perform the requested action on the given location. Optionally overridable. The default implementation returns null.

  Overrides:
    `getLocationPosition` in class `SparseGridPortrayal2D`

### hitOrDraw

    protected void hitOrDraw(java.awt.Graphics2D graphics,
                             DrawInfo2D info,
                             Bag putInHere)

  Description copied from class: `FieldPortrayal2D`
  Instead of overriding the draw and hitObjects methods, you can optionally override this method to provide both the draw(...) and hitObjects(...) functionality in a single method, as it's common that these two methods have nearly identical code. You should test which operation to do based on whether or not graphics is null (if it is, you're hitting, else you're drawing).

  Overrides:
    `hitOrDraw` in class `SparseGridPortrayal2D`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD